# Oppgave 4
# This file should maybe be called "my_stat_lib.py"

# ikke bruk eksisterende Python-funksjoner som heter
# mean median mode max min

def mean(data):
    """
    Find the arithmetic mean value of a list of integers.
    mean = sum of all elements / length of list
    You can assume that data has the right format: [ int, int, ... ]
    """
    return sum(data) / len(data)

def median(data):
    """
    Find the median value of a list of integers.
    median = middle of the sorted values
    If the list has an even length, take the mean of the two middle values
    You can assume that data has the right format: [ int, int, ... ]
    """

    sorted_data = sorted(data)
    if len(data) % 2 == 0:
        i0 = (len(data) // 2) - 1 # Ex, len(list) is 8, i0 is 3
        i1 = i0 + 1 # and i1 is 4
        return (sorted_data[i0] + sorted_data[i1]) / 2
    else:
        return sorted_data[len(data) // 2] # Ex, len(list) is 3, result is 1

def mode(data):
    """
    Find the modal value of a list of integers.
    mode = the value that is most often in the list
    If there are several modes, it's enough to return one of them.
    You can assume that data has the right format: [ int, int, ... ]
    """

    histogram = {}
    for n in data:
        histogram[n] = histogram[n] + 1 if n in histogram else 1

    max_count = 0
    max_n = None

    for n, count in histogram.items():
        if count > max_count:
            max_count = count
            max_n = n

    return max_n


def mode_v2(data):
    """
    Find the modal value of a list of integers.
    mode = the value that is most often in the list
    If there are several modes, it's enough to return one of them.
    You can assume that data has the right format: [ int, int, ... ]
    """
    from collections import Counter
    histogram = Counter(data)
    return histogram.most_common(1)[0][1]


def min(data):
    """
    Find the minimum value of a list of integers.
    You can assume that data has the right format: [ int, int, ... ]
    """
    min_data = data[0]
    for x in data[1:]:
        if x < min_data:
            min_data = x
    return min_data

def max(data):
    """
    Find the maximum value of a list of integers.
    You can assume that data has the right format: [ int, int, ... ]
    """
    max_data = data[0]
    for x in data[1:]:
        if x > max_data:
            max_data = x
    return max_data
